#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "ChallengeSetViewData.h"
#include "EChallengesMenuChallengeSetState.h"
#include "CustomizationRewardViewData.h"
#include "ChallengesMenuPresenter.generated.h"

class UUserWidget;
class USubPresenter;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UChallengesMenuPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> ChallengesMenuWidgetClass;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USubPresenter* _activeSubPresenter;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<FChallengeSetViewData> _challengeSetViewData;

private:
	UFUNCTION(BlueprintCallable)
	void OnTabSelected(const int32 selectedKey);

public:
	UFUNCTION(BlueprintCallable)
	void OnStoreRedirectionRequested(const FString& challengeSetId, const EChallengesMenuChallengeSetState& tabState, const FCustomizationRewardViewData& selectedItem);

private:
	UFUNCTION(BlueprintCallable)
	void OnSettingsButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnBackButtonClicked();

public:
	UChallengesMenuPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UChallengesMenuPresenter) { return 0; }
